import DataLoader from 'dataloader';
export class BaseDataLoader {
    constructor(options = {}) {
        this.options = options;
        this.id = BaseDataLoader.ID_COUNT;
        BaseDataLoader.ID_COUNT++;
    }
    createDataLoader() {
        return new DataLoader(async (ids) => {
            var _a, _b;
            let results;
            if (this.options.hooks) {
                const beforeHookResult = await this.options.hooks.beforeLoad();
                results = await this.load(ids);
                await ((_b = (_a = this.options.hooks).afterLoad) === null || _b === void 0 ? void 0 : _b.call(_a, beforeHookResult));
            }
            else {
                results = await this.load(ids);
            }
            return results;
        });
    }
    getDataLoader(context) {
        var _a, _b;
        context.dataLoaders = (_a = context.dataLoaders) !== null && _a !== void 0 ? _a : {};
        context.dataLoaders[this.id] = (_b = context.dataLoaders[this.id]) !== null && _b !== void 0 ? _b : this.createDataLoader();
        return context.dataLoaders[this.id];
    }
}
BaseDataLoader.ID_COUNT = 0;
