import DataLoader from 'dataloader';
import { DataLoaderContext } from './data-loader-context';
export interface DataLoaderHookOptions<T> {
    beforeLoad: () => T | Promise<T>;
    afterLoad?: (value: T) => void | Promise<void>;
}
export interface DataLoaderOptions<T> {
    hooks?: DataLoaderHookOptions<T>;
}
export declare abstract class BaseDataLoader<Entity, ID, Result, HookResult = unknown> {
    private readonly options;
    private static ID_COUNT;
    private readonly id;
    protected constructor(options?: DataLoaderOptions<HookResult>);
    protected abstract loadByIds: (ids: ID[]) => Promise<Result>;
    protected abstract load(ids: ReadonlyArray<ID>): Promise<(Entity | Error)[]>;
    private createDataLoader;
    getDataLoader(context: DataLoaderContext): DataLoader<ID, Entity>;
}
